package cn.com.qmth.scancentral.bean;

import cn.com.qmth.scancentral.enums.ExamMode;
import cn.com.qmth.scancentral.enums.ImageTransferMode;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import java.util.List;

public class ExamConfigDomain {

    public interface ExamConfigInit {

    }

    @NotNull(message = "考试ID不能为空")
    private Long id;

    @NotNull(message = "扫描模式不能为空", groups = ExamConfigInit.class)
    private ExamMode mode;

    @NotNull(message = "整袋扫描不能为空", groups = ExamConfigInit.class)
    private Boolean scanByPackage;

    @NotNull(message = "启用实时审核不能为空", groups = ExamConfigInit.class)
    private Boolean enableSyncVerify;

    @NotNull(message = "是否允许缺页不能为空", groups = ExamConfigInit.class)
    private Boolean allowUnexistPaper;

    @NotNull(message = "答题卡正面题卡类型不能为空", groups = ExamConfigInit.class)
    @Min(value = 1, message = "题卡类型不能小于1", groups = ExamConfigInit.class)
    private Integer answerFrontCardType;

    @NotNull(message = "是否允许单页题卡不能为空", groups = ExamConfigInit.class)
    private Boolean enableSinglePageAnswer;

    @NotNull(message = "图片转存规则不能为空", groups = ExamConfigInit.class)
    private ImageTransferMode imageTransferMode;

    private List<String> paperTypeBarcodeContent;

    private String absentBarcodeContent;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public ExamMode getMode() {
        return mode;
    }

    public void setMode(ExamMode mode) {
        this.mode = mode;
    }

    public Boolean getScanByPackage() {
        return scanByPackage;
    }

    public void setScanByPackage(Boolean scanByPackage) {
        this.scanByPackage = scanByPackage;
    }

    public Boolean getEnableSyncVerify() {
        return enableSyncVerify;
    }

    public void setEnableSyncVerify(Boolean enableSyncVerify) {
        this.enableSyncVerify = enableSyncVerify;
    }

    public Boolean getAllowUnexistPaper() {
        return allowUnexistPaper;
    }

    public void setAllowUnexistPaper(Boolean allowUnexistPaper) {
        this.allowUnexistPaper = allowUnexistPaper;
    }

    public Integer getAnswerFrontCardType() {
        return answerFrontCardType;
    }

    public void setAnswerFrontCardType(Integer answerFrontCardType) {
        this.answerFrontCardType = answerFrontCardType;
    }

    public Boolean getEnableSinglePageAnswer() {
        return enableSinglePageAnswer;
    }

    public void setEnableSinglePageAnswer(Boolean enableSinglePageAnswer) {
        this.enableSinglePageAnswer = enableSinglePageAnswer;
    }

    public ImageTransferMode getImageTransferMode() {
        return imageTransferMode;
    }

    public void setImageTransferMode(ImageTransferMode imageTransferMode) {
        this.imageTransferMode = imageTransferMode;
    }

    public List<String> getPaperTypeBarcodeContent() {
        return paperTypeBarcodeContent;
    }

    public void setPaperTypeBarcodeContent(List<String> paperTypeBarcodeContent) {
        this.paperTypeBarcodeContent = paperTypeBarcodeContent;
    }

    public String getAbsentBarcodeContent() {
        return absentBarcodeContent;
    }

    public void setAbsentBarcodeContent(String absentBarcodeContent) {
        this.absentBarcodeContent = absentBarcodeContent;
    }

}
