package cn.com.qmth.scancentral.bean.answersave;

import javax.validation.Valid;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

public class AnswerDomain {

    @NotNull(message = "batchId不能为空")
    private Long batchId;

    @NotBlank(message = "subjectCode不能为空")
    private String subjectCode;

    @NotBlank(message = "examNumber不能为空")
    private String examNumber;

    @NotNull(message = "cardNumber不能为空")
    @Min(value = 1, message = "cardNumber不能小于1")
    private Integer cardNumber;

    @Valid
    @NotNull(message = "papers不能为空")
    @Size(min = 1, message = "papers不能为空")
    private List<AnswerPaper> papers;

    public Long getBatchId() {
        return batchId;
    }

    public void setBatchId(Long batchId) {
        this.batchId = batchId;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public Integer getCardNumber() {
        return cardNumber;
    }

    public void setCardNumber(Integer cardNumber) {
        this.cardNumber = cardNumber;
    }

    public List<AnswerPaper> getPapers() {
        return papers;
    }

    public void setPapers(List<AnswerPaper> papers) {
        this.papers = papers;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

}
