package cn.com.qmth.scancentral.bean.omredit;

import javax.validation.Valid;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import cn.com.qmth.scancentral.enums.OmrField;

public class OmrFieldEditDomain {

    @NotNull(message = "考试ID不能为空")
    private Long examId;

    @NotBlank(message = "subjectCode不能为空")
    private String subjectCode;

    @NotBlank(message = "准考证号不能为空")
    private String examNumber;

    @NotNull(message = "paper.number不能为空")
    @Min(value = 1, message = "paper.number不能小于1")
    private Integer paperNumber;

    @NotNull(message = "pageIndex不能为空")
    @Min(value = 1, message = "pageIndex不能小于1")
    @Max(value = 2, message = "pageIndex不能大于2")
    private Integer pageIndex;

    @NotNull(message = "field不能为空")
    private OmrField field;

    @Valid
    @NotBlank(message = "value不能为空")
    private String value;

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getPaperNumber() {
        return paperNumber;
    }

    public void setPaperNumber(Integer paperNumber) {
        this.paperNumber = paperNumber;
    }

    public Integer getPageIndex() {
        return pageIndex;
    }

    public void setPageIndex(Integer pageIndex) {
        this.pageIndex = pageIndex;
    }

    public OmrField getField() {
        return field;
    }

    public void setField(OmrField field) {
        this.field = field;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

}
