package cn.com.qmth.scancentral.bean.refix;

import javax.validation.Valid;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

public class AnswerRefixDomain {

    @NotNull(message = "考试Id不能为空")
    private Long examId;

    @NotBlank(message = "subjectCode不能为空")
    private String subjectCode;

    @NotBlank(message = "准考证号不能为空")
    private String examNumber;

    @NotNull(message = "卡格式编号不能为空")
    @Min(value = 1, message = "卡格式编号不能小于1")
    private Integer cardNumber;

    @Valid
    @NotNull(message = "paper不能为空")
    @Size(min = 1, message = "paper不能为空")
    private List<PaperRefixDomain> papers;

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public Integer getCardNumber() {
        return cardNumber;
    }

    public void setCardNumber(Integer cardNumber) {
        this.cardNumber = cardNumber;
    }

    public List<PaperRefixDomain> getPapers() {
        return papers;
    }

    public void setPapers(List<PaperRefixDomain> papers) {
        this.papers = papers;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public PaperRefixDomain findPaperDomain(Integer paperNumber, Long paperId) {
        for (PaperRefixDomain domain : papers) {
            if (domain.getId().equals(paperId) && domain.getNumber().equals(paperNumber)) {
                return domain;
            }
        }
        return null;
    }
}
