package cn.com.qmth.scancentral.bean.refix;

import cn.com.qmth.scancentral.bean.answersave.ArrayResult;
import cn.com.qmth.scancentral.bean.answersave.BoolResult;
import cn.com.qmth.scancentral.bean.answersave.StringResult;
import cn.com.qmth.scancentral.entity.PaperPageEntity;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import java.util.List;

public class PageRefixDomain {

    @NotNull(message = "paper.page.index不能为空")
    @Min(value = 1, message = "paper.page.index不能小于1")
    private Integer index;

    private List<String> sliceUri;

    private BoolResult absent;

    private BoolResult breach;

    private StringResult paperType;

    private ArrayResult question;

    private ArrayResult selective;

    private String recogData;

    public Integer getIndex() {
        return index;
    }

    public void setIndex(Integer index) {
        this.index = index;
    }

    public List<String> getSliceUri() {
        return sliceUri;
    }

    public void setSliceUri(List<String> sliceUri) {
        this.sliceUri = sliceUri;
    }

    public BoolResult getAbsent() {
        return absent;
    }

    public void setAbsent(BoolResult absent) {
        this.absent = absent;
    }

    public BoolResult getBreach() {
        return breach;
    }

    public void setBreach(BoolResult breach) {
        this.breach = breach;
    }

    public StringResult getPaperType() {
        return paperType;
    }

    public void setPaperType(StringResult paperType) {
        this.paperType = paperType;
    }

    public ArrayResult getQuestion() {
        return question;
    }

    public void setQuestion(ArrayResult question) {
        this.question = question;
    }

    public ArrayResult getSelective() {
        return selective;
    }

    public void setSelective(ArrayResult selective) {
        this.selective = selective;
    }

    public String getRecogData() {
        return recogData;
    }

    public void setRecogData(String recogData) {
        this.recogData = recogData;
    }

    public PaperPageEntity update(PaperPageEntity page, List<String> barcodeContents) {
        page.setSlicePath(sliceUri);
        page.setAbsent(absent);
        page.setBreach(breach);
        page.setPaperType(paperType);
        page.setQuestion(question);
        page.setSelective(selective);
        page.setRecogData(recogData);
        page.checkPaperType(barcodeContents);
        return page;
    }
}
