package cn.com.qmth.scancentral.config;

import java.io.File;
import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import cn.com.qmth.scancentral.util.FileUtil;

@Component
public class InitData implements CommandLineRunner {

    private static final Logger log = LoggerFactory.getLogger(InitData.class);

    @Autowired
    private SysProperty sysProperty;

    @Override
    public void run(String... args) throws IOException {
        // log.info("开始系统初始化...");
        // 自动创建图片转存目录
        String dir = sysProperty.getTransferDir();
        File dfile = new File(dir);
        if (!dfile.exists()) {
            dfile.mkdirs();
            log.info("创建图片转存目录：{}", dir);
        }

        File temp = new File("temp");
        if (temp.exists()) {
            FileUtil.deleteDirectory(temp);
        }
    }

}
