package cn.com.qmth.scancentral.consumer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import cn.com.qmth.scancentral.service.SubjectService;
import cn.com.qmth.scancentral.vo.subject.DataExportTaskVo;

@Scope("prototype")
@Service
public class AnswerDataExportConsumer implements Runnable {

    protected static final Logger log = LoggerFactory.getLogger(AnswerDataExportConsumer.class);

    private DataExportTaskVo vo;

    @Autowired
    private SubjectService subjectService;

    @Override
    public void run() {
        try {
            subjectService.answerDataExportDispose(vo);
        } catch (Exception e) {
            log.error("DBF导出出错", e);
        }
    }

    public DataExportTaskVo getVo() {
        return vo;
    }

    public void setVo(DataExportTaskVo vo) {
        this.vo = vo;
    }

}
