package cn.com.qmth.scancentral.consumer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import cn.com.qmth.scancentral.service.StudentService;
import cn.com.qmth.scancentral.vo.asynctask.BreachAndStatusImportTaskVo;

@Scope("prototype")
@Service
public class BreachImportConsumer implements Runnable {

    protected static final Logger log = LoggerFactory.getLogger(BreachImportConsumer.class);

    private BreachAndStatusImportTaskVo vo;

    @Autowired
    private StudentService studentService;

    @Override
    public void run() {
        try {
            studentService.breachImportDispose(vo);
        } catch (Exception e) {
            log.error("违纪导入出错", e);
        }
    }

    public BreachAndStatusImportTaskVo getVo() {
        return vo;
    }

    public void setVo(BreachAndStatusImportTaskVo vo) {
        this.vo = vo;
    }

}
