package cn.com.qmth.scancentral.consumer;

import java.util.concurrent.CountDownLatch;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;

import cn.com.qmth.scancentral.service.StudentService;
import cn.com.qmth.scancentral.vo.StudentUploadVo;

@Scope("prototype")
@Service
public class PictureCopyConsumer implements Runnable {

    private CountDownLatch endGate;

    private StudentUploadVo vo;

    @Autowired
    private StudentService studentService;

    @Override
    public void run() {
        try {
            studentService.pictureCopy(vo);
        } finally {
            endGate.countDown();
        }
    }

    public StudentUploadVo getVo() {
        return vo;
    }

    public void setVo(StudentUploadVo vo) {
        this.vo = vo;
    }

    public CountDownLatch getEndGate() {
        return endGate;
    }

    public void setEndGate(CountDownLatch endGate) {
        this.endGate = endGate;
    }

}
