package cn.com.qmth.scancentral.controller.admin;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.BatchService;
import cn.com.qmth.scancentral.vo.SubjectVo;
import cn.com.qmth.scancentral.vo.batch.BatchDeviceQuery;
import cn.com.qmth.scancentral.vo.batch.BatchQuery;
import cn.com.qmth.scancentral.vo.batch.BatchStudentSimpleVo;
import cn.com.qmth.scancentral.vo.batch.BatchSubjectQuery;
import cn.com.qmth.scancentral.vo.batch.BatchVo;
import cn.com.qmth.scancentral.vo.device.DeviceVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "批次接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/admin/batch")
@Aac(strict = false, auth = true)
public class BatchController extends BaseController {

    @Autowired
    private BatchService batchService;

    @ApiOperation(value = "获取扫描批次科目列表")
    @PostMapping("subject/list")
    public List<SubjectVo> subjectList(BatchSubjectQuery req) {
        return batchService.subjectList(req);
    }

    @ApiOperation(value = "获取扫描批次机器列表")
    @PostMapping("device/list")
    public List<DeviceVo> deviceList(BatchDeviceQuery req) {
        return batchService.deviceList(req);
    }

    @ApiOperation(value = "获取批次列表")
    @PostMapping("list")
    public List<BatchVo> batchList(BatchQuery req) {
        return batchService.batchList(req);
    }

    @ApiOperation(value = "查询批次考生列表")
    @PostMapping("student/list")
    public List<BatchStudentSimpleVo> studentList(@RequestParam Long batchId) {
        return batchService.studentList(batchId);
    }

}