package cn.com.qmth.scancentral.controller.admin;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.BatchService;
import cn.com.qmth.scancentral.vo.UpdateTimeVo;
import cn.com.qmth.scancentral.vo.verify.VerifyTaskVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "审核员实时审核")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/auditor/batch/verify")
@Aac(strict = false, auth = true)
public class BatchVerifyController extends BaseController {

    @Autowired
    private BatchService batchService;

    @ApiOperation(value = "获取实时审核任务")
    @RequestMapping(value = "/get", method = RequestMethod.POST)
    public VerifyTaskVo answerGet(@RequestParam Long examId) {
        User user = getAccessUser();
        return batchService.getVerifyTask(examId, user);
    }

    @ApiOperation(value = "实时审核任务处理")
    @RequestMapping(value = "/submit", method = RequestMethod.POST)
    public UpdateTimeVo answerSubmit(@RequestParam Long batchId, @RequestParam Boolean confirm) {
        User user = getAccessUser();
        batchService.verify(batchId, confirm, user);
        return result(System.currentTimeMillis());
    }

    @ApiOperation(value = "实时审核任务释放")
    @RequestMapping(value = "/release", method = RequestMethod.POST)
    public Object answerRelease(@RequestParam Long examId) {
        User user = getAccessUser();
        batchService.releaseVerifyTask(examId, user.getAccount());
        return success(true);
    }
}
