package cn.com.qmth.scancentral.controller.admin;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.core.collection.PageResult;

import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.MarkSiteService;
import cn.com.qmth.scancentral.vo.ResultVo;
import cn.com.qmth.scancentral.vo.marksite.MarkSiteDomain;
import cn.com.qmth.scancentral.vo.marksite.MarkSitePageQuery;
import cn.com.qmth.scancentral.vo.marksite.MarkSitePageVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "评卷点接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/admin/mark-site")
@Aac(strict = false, auth = true)
public class MarkSiteController extends BaseController {

    @Autowired
    private MarkSiteService markSiteService;

    @ApiOperation(value = "分页查询评卷点")
    @PostMapping(value = "page")
    public PageResult<MarkSitePageVo> page(@Validated MarkSitePageQuery query) {
        return markSiteService.findMarkSitePage(query);
    }

    @ApiOperation(value = "新增、修改评卷点")
    @PostMapping(value = "save")
    public ResultVo save(MarkSiteDomain domain) {
        markSiteService.saveMarkSite(domain, getAccessUser());
        return new ResultVo(System.currentTimeMillis());
    }

    @ApiOperation(value = "删除评卷点设置")
    @PostMapping(value = "delete")
    public ResultVo delete(@RequestParam Long id) {
        markSiteService.removeById(id);
        return new ResultVo(System.currentTimeMillis());
    }
}