package cn.com.qmth.scancentral.controller.scan;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.api.utils.RequestUtil;

import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.AdapteFileService;
import cn.com.qmth.scancentral.service.AnswerCardService;
import cn.com.qmth.scancentral.vo.AnswerCardVo;
import cn.com.qmth.scancentral.vo.UriVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "扫描功能-答题卡接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/scan/card")
@Aac(strict = false, auth = true)
public class ScanCardController extends BaseController {

    @Autowired
    private AnswerCardService answerCardService;

    @Autowired
    private AdapteFileService adapteFileService;

    @ApiOperation(value = "答题卡卡格式列表")
    @RequestMapping(value = "/list", method = RequestMethod.POST)
    public List<AnswerCardVo> cardList(HttpServletRequest request, @RequestParam Long examId) {
        return answerCardService.listByExamIdForScanner(examId, getAccessUser(), RequestUtil.getIpAddress(request));
    }

    @ApiOperation(value = "答题卡适配卡格式上传")
    @RequestMapping(value = "/adapte/upload", method = RequestMethod.POST)
    public UriVo adapteUpload(HttpServletRequest request, @RequestParam Long examId, @RequestParam Integer cardNumber,
            @RequestParam MultipartFile file, @RequestParam String md5, @RequestParam Integer dpi) {
        return adapteFileService.save(RequestUtil.getIpAddress(request), getAccessUser().getRole(), examId, cardNumber,
                md5, dpi, file);
    }
}
