package cn.com.qmth.scancentral.controller.scan;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;

import cn.com.qmth.scancentral.controller.BaseController;
import cn.com.qmth.scancentral.service.StudentService;
import cn.com.qmth.scancentral.vo.student.StudentQuery;
import cn.com.qmth.scancentral.vo.student.StudentVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "扫描功能-考生接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/scan/student")
@Aac(strict = false, auth = true)
public class ScanStudentController extends BaseController {

    @Autowired
    private StudentService studentService;

    @ApiOperation(value = "整袋考生查询")
    @RequestMapping(value = "/package/list", method = RequestMethod.POST)
    public List<StudentVo> packageList(StudentQuery query) {
        return studentService.packageList(query);
    }

    @ApiOperation(value = "考生查询")
    @RequestMapping(value = "/find", method = RequestMethod.POST)
    public StudentVo student(@Validated StudentQuery query) {
        return studentService.findOne(query);
    }

}
