package cn.com.qmth.scancentral.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import cn.com.qmth.scancentral.bean.BatchQueryDomain;
import cn.com.qmth.scancentral.bean.WorkloadDomain;
import cn.com.qmth.scancentral.entity.BatchEntity;
import cn.com.qmth.scancentral.enums.BatchStatus;
import cn.com.qmth.scancentral.enums.CheckStatus;
import cn.com.qmth.scancentral.enums.VerifyStatus;
import cn.com.qmth.scancentral.vo.BatchQueryVo;
import cn.com.qmth.scancentral.vo.ScannerWorkloadVo;
import cn.com.qmth.scancentral.vo.SubjectVo;
import cn.com.qmth.scancentral.vo.batch.*;
import cn.com.qmth.scancentral.vo.batchdetail.BatchDetailDO;
import cn.com.qmth.scancentral.vo.device.DeviceVo;

public interface BatchDao extends BaseMapper<BatchEntity> {

    void updateScanCount(@Param("id") Long id);

    void updateAssignedCount(@Param("id") Long id);

    List<Long> batchSummary(@Param("query") BatchQueryDomain query);

    IPage<BatchQueryVo> batchQueryPage(Page<BatchQueryVo> page, @Param("query") BatchQueryDomain query);

    List<BatchDetailDO> batchDetailList(@Param("id") Long id);

    IPage<BatchEntity> findUnVerify(Page<BatchEntity> page, @Param("examId") Long examId,
            @Param("status") VerifyStatus status);

    Integer findStudentCountByBatch(@Param(value = "batchId") Long batchId);

    List<String> batchScanner(@Param("examId") Long examId);

    List<ScannerWorkloadVo> workload(@Param("req") WorkloadDomain domain);

    IPage<BatchEntity> findUnCheck(Page<BatchEntity> page, @Param("examId") Long examId,
            @Param("batchStatus") BatchStatus batchStatus, @Param("checkStatus") CheckStatus checkStatus);

    List<BatchDetailDO> batchDetailListToCheck(@Param("id") Long id, @Param("needCheck") Boolean needCheck);

    BatchEntity getHistory(@Param(value = "examId") Long examId, @Param("batchId") Long batchId,
            @Param("userId") Long userId, @Param("status") CheckStatus status);

    List<SubjectVo> subjectList(@Param(value = "req") BatchSubjectQuery req);

    List<DeviceVo> deviceList(@Param(value = "req") BatchDeviceQuery req);

    List<BatchVo> batchList(@Param(value = "req") BatchQuery req);

    List<BatchStudentSimpleVo> studentList(@Param(value = "batchId") Long batchId);

}
