package cn.com.qmth.scancentral.entity;

import cn.com.qmth.scancentral.vo.ScanAnswerInfoVo;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

// 考试汇总信息
@TableName(value = "sc_exam_summary", autoResultMap = true)
public class ExamSummaryEntity {

    @TableId(type = IdType.INPUT)
    private Long id;

    private Integer studentCount = 0;

    private Integer subjectCount = 0;

    private Integer batchCount = 0;

    private Integer answerScannedCount = 0;

    private Integer answerUnexistCount = 0;

    private Integer answerManualAbsentCount = 0;

    private Integer answerOmrAbsentCount = 0;

    private Integer answerAbsentSuspectCount = 0;

    private Integer answerIncompleteCount = 0;

    private Integer answerAssignedCount = 0;

    private Integer answerMismatchCount = 0;

    private Integer answerBatchCount = 0;

    private Integer packageTotalCount = 0;

    private Integer packageScannedCount = 0;

    private Integer studentAnswerCount = 0;

    private Double uploadProgress = 0.0;

    public void updateScanAnswer(ScanAnswerInfoVo info) {
        this.studentCount = info.getTotalCount();
        this.answerScannedCount = info.getScannedCount();
        this.answerUnexistCount = info.getUnexistCount();
        this.answerManualAbsentCount = info.getManualAbsentCount();
        this.answerOmrAbsentCount = info.getOmrAbsentCount();
        this.answerAbsentSuspectCount = info.getAbsentSuspectCount();
        this.answerIncompleteCount = info.getIncompleteCount();
        this.answerAssignedCount = info.getAssignedCount();
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getStudentCount() {
        return studentCount;
    }

    public void setStudentCount(Integer studentCount) {
        this.studentCount = studentCount;
    }

    public Integer getSubjectCount() {
        return subjectCount;
    }

    public void setSubjectCount(Integer subjectCount) {
        this.subjectCount = subjectCount;
    }

    public Integer getBatchCount() {
        return batchCount;
    }

    public void setBatchCount(Integer batchCount) {
        this.batchCount = batchCount;
    }

    public Integer getAnswerScannedCount() {
        return answerScannedCount;
    }

    public void setAnswerScannedCount(Integer answerScannedCount) {
        this.answerScannedCount = answerScannedCount;
    }

    public Integer getAnswerUnexistCount() {
        return answerUnexistCount;
    }

    public void setAnswerUnexistCount(Integer answerUnexistCount) {
        this.answerUnexistCount = answerUnexistCount;
    }

    public Integer getAnswerManualAbsentCount() {
        return answerManualAbsentCount;
    }

    public void setAnswerManualAbsentCount(Integer answerManualAbsentCount) {
        this.answerManualAbsentCount = answerManualAbsentCount;
    }

    public Integer getAnswerOmrAbsentCount() {
        return answerOmrAbsentCount;
    }

    public void setAnswerOmrAbsentCount(Integer answerOmrAbsentCount) {
        this.answerOmrAbsentCount = answerOmrAbsentCount;
    }

    public Integer getAnswerAbsentSuspectCount() {
        return answerAbsentSuspectCount;
    }

    public void setAnswerAbsentSuspectCount(Integer answerAbsentSuspectCount) {
        this.answerAbsentSuspectCount = answerAbsentSuspectCount;
    }

    public Integer getAnswerIncompleteCount() {
        return answerIncompleteCount;
    }

    public void setAnswerIncompleteCount(Integer answerIncompleteCount) {
        this.answerIncompleteCount = answerIncompleteCount;
    }

    public Integer getAnswerAssignedCount() {
        return answerAssignedCount;
    }

    public void setAnswerAssignedCount(Integer answerAssignedCount) {
        this.answerAssignedCount = answerAssignedCount;
    }

    public Integer getAnswerMismatchCount() {
        return answerMismatchCount;
    }

    public void setAnswerMismatchCount(Integer answerMismatchCount) {
        this.answerMismatchCount = answerMismatchCount;
    }

    public Integer getAnswerBatchCount() {
        return answerBatchCount;
    }

    public void setAnswerBatchCount(Integer answerBatchCount) {
        this.answerBatchCount = answerBatchCount;
    }

    public Integer getPackageTotalCount() {
        return packageTotalCount;
    }

    public void setPackageTotalCount(Integer packageTotalCount) {
        this.packageTotalCount = packageTotalCount;
    }

    public Integer getPackageScannedCount() {
        return packageScannedCount;
    }

    public void setPackageScannedCount(Integer packageScannedCount) {
        this.packageScannedCount = packageScannedCount;
    }

    public Double getUploadProgress() {
        return uploadProgress;
    }

    public void setUploadProgress(Double uploadProgress) {
        this.uploadProgress = uploadProgress;
    }

    public Integer getStudentAnswerCount() {
        return studentAnswerCount;
    }

    public void setStudentAnswerCount(Integer studentAnswerCount) {
        this.studentAnswerCount = studentAnswerCount;
    }

}
