package cn.com.qmth.scancentral.entity;

import cn.com.qmth.scancentral.bean.answersave.ArrayResult;
import cn.com.qmth.scancentral.bean.answersave.BoolResult;
import cn.com.qmth.scancentral.bean.answersave.StringResult;
import cn.com.qmth.scancentral.entity.base.AuditingWithoutIdEntity;
import cn.com.qmth.scancentral.enums.OmrType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.github.jeffreyning.mybatisplus.anno.MppMultiId;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

@TableName(value = "sc_paper_page", autoResultMap = true)
public class PaperPageEntity extends AuditingWithoutIdEntity {

    private static final long serialVersionUID = -182520914017960004L;

    @MppMultiId
    private Long paperId;

    @MppMultiId
    private Integer pageIndex;

    @TableField(value = "absent", typeHandler = JacksonTypeHandler.class)
    private BoolResult absent;

    @TableField(value = "breach", typeHandler = JacksonTypeHandler.class)
    private BoolResult breach;

    // ？属于异常 ，#属于空白
    @TableField(value = "paper_type", typeHandler = JacksonTypeHandler.class)
    private StringResult paperType;

    @TableField(value = "question", typeHandler = JacksonTypeHandler.class)
    private ArrayResult question;

    @TableField(value = "selective", typeHandler = JacksonTypeHandler.class)
    private ArrayResult selective;

    private String sheetPath;

    @TableField(value = "slice_path", typeHandler = JacksonTypeHandler.class)
    private List<String> slicePath;

    private String recogData;

    public Long getPaperId() {
        return paperId;
    }

    public void setPaperId(Long paperId) {
        this.paperId = paperId;
    }

    public Integer getPageIndex() {
        return pageIndex;
    }

    public void setPageIndex(Integer pageIndex) {
        this.pageIndex = pageIndex;
    }

    public BoolResult getAbsent() {
        return absent;
    }

    public void setAbsent(BoolResult absent) {
        this.absent = absent;
    }

    public BoolResult getBreach() {
        return breach;
    }

    public void setBreach(BoolResult breach) {
        this.breach = breach;
    }

    public StringResult getPaperType() {
        return paperType;
    }

    public void setPaperType(StringResult paperType) {
        this.paperType = paperType;
    }

    public ArrayResult getQuestion() {
        return question;
    }

    public void setQuestion(ArrayResult question) {
        this.question = question;
    }

    public ArrayResult getSelective() {
        return selective;
    }

    public void setSelective(ArrayResult selective) {
        this.selective = selective;
    }

    public String getSheetPath() {
        return sheetPath;
    }

    public void setSheetPath(String sheetPath) {
        this.sheetPath = sheetPath;
    }

    public List<String> getSlicePath() {
        return slicePath;
    }

    public void setSlicePath(List<String> slicePath) {
        this.slicePath = slicePath;
    }

    public String getRecogData() {
        return recogData;
    }

    public void setRecogData(String recogData) {
        this.recogData = recogData;
    }

    public boolean isQuestionFilled() {
        if (question != null) {
            if (CollectionUtils.isEmpty(question.getResult())) {
                return false;
            }
            for (String s : question.getResult()) {
                if (!"#".equals(s)) {
                    return true;
                }
            }
            return false;
        }
        return false;
    }

    public void checkPaperType(List<String> barcodeContents) {
        if (paperType != null) {
            paperType.setResult(StringUtils.trimToEmpty(paperType.getResult()));
            if (paperType.getType() == OmrType.BARCODE) {
                if (paperType.getResult().length() == 0) {
                    paperType.setResult("#");
                } else if (CollectionUtils.isNotEmpty(barcodeContents)
                        && !barcodeContents.contains(paperType.getResult())) {
                    paperType.setResult("?");
                }
            } else if (paperType.getType() == OmrType.FILL_AREA) {
                if (paperType.getResult().startsWith("?")) {
                    paperType.setResult(paperType.getResult().substring(1));
                }
                if (paperType.getResult().length() == 0) {
                    paperType.setResult("#");
                }
            }
        }
    }
}
