package cn.com.qmth.scancentral.entity;

import cn.com.qmth.scancentral.entity.base.AuditingWithoutIdEntity;
import cn.com.qmth.scancentral.enums.ExamStatus;
import cn.com.qmth.scancentral.enums.ImageCheckStatus;
import cn.com.qmth.scancentral.enums.ScanStatus;
import cn.com.qmth.scancentral.enums.UploadStatus;
import com.baomidou.mybatisplus.annotation.*;

// 考生
@TableName("sc_student")
public class StudentEntity extends AuditingWithoutIdEntity {

    /**
     *
     */
    private static final long serialVersionUID = -7208399777465643821L;

    @TableId(type = IdType.INPUT)
    private Long id;

    private Long examId;

    private String examNumber;

    private String name;

    private String subjectCode;

    // 卷袋编号
    private String packageCode;

    // 考点
    private String examSite;

    // 考点名称
    private String examSiteName;

    // 考场
    private String examRoom;

    // 座位号
    private String seatNumber;

    // 校区名称
    private String campusName;

    // 校区代码
    private String campusCode;

    // 省份
    private String province;

    // 设备
    private String device;

    private ScanStatus status;

    // 识别缺考
    private Boolean omrAbsent;

    // 是否有客观题填涂
    private Boolean questionFilled;

    // 是否有主观题填涂
    private Boolean subjectiveFilled;

    // 是否人工绑定
    private Boolean assigned;

    // 是否标记异常
    private Boolean absentSuspect;

    // 是否有缺页
    private Boolean incomplete;

    // 考试状态
    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private ExamStatus examStatus;

    // 违纪码
    private String breachCode;

    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private Integer cardNumber;

    private UploadStatus fileUploadStatus;

    private UploadStatus dataUploadStatus;

    @TableField(updateStrategy = FieldStrategy.IGNORED)
    private String paperType;

    // 数据检查标记
    private Boolean checkMark;

    // 人工绑定确认次数
    private Integer assignedCheckCount;

    // 人工绑定异常标记
    private Boolean assignedSuspect;

    private ImageCheckStatus imageCheckStatus;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getPackageCode() {
        return packageCode;
    }

    public void setPackageCode(String packageCode) {
        this.packageCode = packageCode;
    }

    public String getExamSite() {
        return examSite;
    }

    public void setExamSite(String examSite) {
        this.examSite = examSite;
    }

    public String getExamRoom() {
        return examRoom;
    }

    public void setExamRoom(String examRoom) {
        this.examRoom = examRoom;
    }

    public String getSeatNumber() {
        return seatNumber;
    }

    public void setSeatNumber(String seatNumber) {
        this.seatNumber = seatNumber;
    }

    public String getCampusName() {
        return campusName;
    }

    public void setCampusName(String campusName) {
        this.campusName = campusName;
    }

    public ScanStatus getStatus() {
        return status;
    }

    public void setStatus(ScanStatus status) {
        this.status = status;
    }

    public Boolean getOmrAbsent() {
        return omrAbsent;
    }

    public void setOmrAbsent(Boolean omrAbsent) {
        this.omrAbsent = omrAbsent;
    }

    public Boolean getAssigned() {
        return assigned;
    }

    public void setAssigned(Boolean assigned) {
        this.assigned = assigned;
    }

    public Boolean getAbsentSuspect() {
        return absentSuspect;
    }

    public void setAbsentSuspect(Boolean absentSuspect) {
        this.absentSuspect = absentSuspect;
    }

    public Boolean getIncomplete() {
        return incomplete;
    }

    public void setIncomplete(Boolean incomplete) {
        this.incomplete = incomplete;
    }

    public Integer getCardNumber() {
        return cardNumber;
    }

    public void setCardNumber(Integer cardNumber) {
        this.cardNumber = cardNumber;
    }

    public Boolean getQuestionFilled() {
        return questionFilled;
    }

    public void setQuestionFilled(Boolean questionFilled) {
        this.questionFilled = questionFilled;
    }

    public UploadStatus getFileUploadStatus() {
        return fileUploadStatus;
    }

    public void setFileUploadStatus(UploadStatus fileUploadStatus) {
        this.fileUploadStatus = fileUploadStatus;
    }

    public UploadStatus getDataUploadStatus() {
        return dataUploadStatus;
    }

    public void setDataUploadStatus(UploadStatus dataUploadStatus) {
        this.dataUploadStatus = dataUploadStatus;
    }

    public String getPaperType() {
        return paperType;
    }

    public void setPaperType(String paperType) {
        this.paperType = paperType;
    }

    public String getDevice() {
        return device;
    }

    public void setDevice(String device) {
        this.device = device;
    }

    public ExamStatus getExamStatus() {
        return examStatus;
    }

    public void setExamStatus(ExamStatus examStatus) {
        this.examStatus = examStatus;
    }

    public String getExamSiteName() {
        return examSiteName;
    }

    public void setExamSiteName(String examSiteName) {
        this.examSiteName = examSiteName;
    }

    public String getCampusCode() {
        return campusCode;
    }

    public void setCampusCode(String campusCode) {
        this.campusCode = campusCode;
    }

    public String getBreachCode() {
        return breachCode;
    }

    public void setBreachCode(String breachCode) {
        this.breachCode = breachCode;
    }

    public Boolean getCheckMark() {
        return checkMark;
    }

    public void setCheckMark(Boolean checkMark) {
        this.checkMark = checkMark;
    }

    public Boolean getSubjectiveFilled() {
        return subjectiveFilled;
    }

    public void setSubjectiveFilled(Boolean subjectiveFilled) {
        this.subjectiveFilled = subjectiveFilled;
    }

    public Integer getAssignedCheckCount() {
        return assignedCheckCount;
    }

    public void setAssignedCheckCount(Integer assignedCheckCount) {
        this.assignedCheckCount = assignedCheckCount;
    }

    public Boolean getAssignedSuspect() {
        return assignedSuspect;
    }

    public void setAssignedSuspect(Boolean assignedSuspect) {
        this.assignedSuspect = assignedSuspect;
    }

    public ImageCheckStatus getImageCheckStatus() {
        return imageCheckStatus;
    }

    public void setImageCheckStatus(ImageCheckStatus imageCheckStatus) {
        this.imageCheckStatus = imageCheckStatus;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

}
