package cn.com.qmth.scancentral.service;

import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.entity.AnswerCardEntity;
import cn.com.qmth.scancentral.vo.AnswerCardVo;
import cn.com.qmth.scancentral.vo.card.CardEdit;
import cn.com.qmth.scancentral.vo.card.CardInfo;
import cn.com.qmth.scancentral.vo.card.CardQuery;
import com.github.jeffreyning.mybatisplus.service.IMppService;
import com.qmth.boot.core.collection.PageResult;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

public interface AnswerCardService extends IMppService<AnswerCardEntity> {

    PageResult<CardInfo> pageQuery(CardQuery query);

    int getCountByExam(Long examId);

    void saveCard(CardEdit info, MultipartFile file);

    @Deprecated
    AnswerCardEntity save(User user, Long examId, Integer number, String subjectCode, String parameter, String remark,
                          Integer paperCount, Boolean singlePage, String md5, Integer dpi, MultipartFile file);

    void delete(User user, Long examId, Integer number);

    List<AnswerCardVo> listByExamId(Long examId);

    List<AnswerCardVo> listByExamIdForScanner(Long examId, User scanner, String device);

    AnswerCardEntity findByExamAndNumber(Long examId, Integer number);

}
