package cn.com.qmth.scancentral.service;

import cn.com.qmth.scancentral.bean.ImportExamDomain;
import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.entity.ExamEntity;
import cn.com.qmth.scancentral.vo.ExamConfigVo;
import cn.com.qmth.scancentral.vo.ExamVo;
import cn.com.qmth.scancentral.vo.auditor.AuditorOverview;
import cn.com.qmth.scancentral.vo.checkimage.RatioVo;
import cn.com.qmth.scancentral.vo.examinfo.ExamEdit;
import cn.com.qmth.scancentral.vo.examinfo.ExamOverview;
import cn.com.qmth.scancentral.vo.examinfo.ExamQuery;
import cn.com.qmth.scancentral.vo.scanexaminfo.ScanExamInfoVo;
import cn.com.qmth.scancentral.vo.scanexamlist.ScanExamListVo;
import cn.com.qmth.scancentral.vo.studentimport.StudentImportConfigVo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;

import java.util.List;

public interface ExamService extends IService<ExamEntity> {

    PageResult<ExamVo> pageQuery(ExamQuery query, User user);

    List<ExamEntity> listEnable();

    Long save(ExamEdit exam);

    ExamOverview getExamOverview(Long id, User accessUser);

    List<ScanExamListVo> getScanExamList();

    ScanExamInfoVo getScanExamInfo(Long id, User accessUser);

    ExamConfigVo getConfigInfo(Long examId);

    StudentImportConfigVo getStudentImportConfig(Long examId);

    void saveStudentImportConfig(StudentImportConfigVo config);

    void saveConfig(ExamConfigVo config, User user);

    ExamEntity save(ImportExamDomain exam);

    RatioVo updateRatio(Long examId, Double ratio);

    void updateDataSyncTime(Long examId);

    void updateCardSyncTime(Long examId);

    void updateExamNumberFillCount(Long examId, Integer examNumberFillCount);

    ExamEntity updateEnableSyncVerify(User user, Long examId, Boolean enableSyncVerify);

    AuditorOverview getAuditorOverview(Long examId, User user);

    void scanSiteSave(Long examId, String scanStie);

    String getScanSite(Long examId);

    Integer getexamNumberFillCount(Long examId);

}
