package cn.com.qmth.scancentral.service;

import java.util.List;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;

import cn.com.qmth.scancentral.entity.OmrGroupEntity;
import cn.com.qmth.scancentral.vo.OmrGroupUpdateVo;
import cn.com.qmth.scancentral.vo.OmrGroupVo;
import cn.com.qmth.scancentral.vo.omr.OmrGroupQuery;

public interface OmrGroupService extends IService<OmrGroupEntity> {

    void deleteById(Long id);

    void resetById(Long id);

    void buildTaskById(Long id);

    PageResult<OmrGroupVo> list(OmrGroupQuery query);

    void updateStage(Long id, Long userId);

    void save(OmrGroupUpdateVo vo);

    List<OmrGroupEntity> findByExamIdAndSubjectCodeAndFixed(Long examId, String subjectCode, Boolean fixed);

    void addFixOmrCondition(Long userId, Long examId, String subjectCode);

    void updateTotalCount(Long id);

    void updateTotalCount(Long examId, String subjectCode);

    List<OmrGroupVo> listByExamIdAndSubjectCode(Long examId, String subjectCode);

    List<OmrGroupEntity> findByExamIdAndSubjectCode(Long examId, String subjectCode);
}
