package cn.com.qmth.scancentral.service;

import java.util.List;

import cn.com.qmth.scancentral.vo.UpdateTimeVo;
import com.github.jeffreyning.mybatisplus.service.IMppService;

import cn.com.qmth.scancentral.bean.ImportSubjectDomain;
import cn.com.qmth.scancentral.bean.SubjectConfigDomain;
import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.entity.SubjectEntity;
import cn.com.qmth.scancentral.vo.SubjectConfigVo;
import cn.com.qmth.scancentral.vo.examinfo.SubjectConfig;
import cn.com.qmth.scancentral.vo.omr.OmrSubjectVo;
import cn.com.qmth.scancentral.vo.subject.DataExportTaskVo;
import cn.com.qmth.scancentral.vo.subject.ScanProgressVo;
import cn.com.qmth.scancentral.vo.subject.SubjectBreachVo;
import cn.com.qmth.scancentral.vo.subject.SubjectCustStatusVo;
import cn.com.qmth.scancentral.vo.subject.TaskIdVo;

public interface SubjectService extends IMppService<SubjectEntity> {

    List<SubjectEntity> listByExamId(Long examId);

    SubjectEntity findByExamIdAndCode(Long examId, String code);

    int countByExamId(Long examId);

    int importSubject(List<ImportSubjectDomain> subjects);

    SubjectConfigVo config(User user, SubjectConfigDomain domain);

    List<SubjectConfig> listConfigByExamId(Long examId);

    ScanProgressVo scanProgress(Long examId, String subjectCode);

    List<SubjectBreachVo> breachList(Long examId);

    List<SubjectCustStatusVo> custStatusList(Long examId);

    TaskIdVo answerDataExport(Long examId, String subjectCode);

    void answerDataExportDispose(DataExportTaskVo vo);

    TaskIdVo sliceDataExport(Long examId, String subjectCode);

    void sliceDataExportDispose(DataExportTaskVo vo);

    void initSubject(Long examId);

    List<OmrSubjectVo> listByExamIdForOmr(Long examId);

    UpdateTimeVo edit(Long examId, String subjectCode, String subjectName);
}
