package cn.com.qmth.scancentral.service;

import cn.com.qmth.scancentral.bean.ImportUserDomain;
import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.entity.UserEntity;
import cn.com.qmth.scancentral.enums.Role;
import cn.com.qmth.scancentral.vo.AuditorVo;
import cn.com.qmth.scancentral.vo.CreateCountVo;
import cn.com.qmth.scancentral.vo.UpdateCountVo;
import cn.com.qmth.scancentral.vo.user.UserEdit;
import cn.com.qmth.scancentral.vo.user.UserQuery;
import cn.com.qmth.scancentral.vo.user.UserVo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;

import java.util.List;

public interface UserService extends IService<UserEntity> {

    UserEntity getByLoginName(String loginName);

    int importUser(List<ImportUserDomain> users);

    List<UserEntity> findByRole(Role... role);

    List<AuditorVo> findAuditor();

    UpdateCountVo updatePassword(List<Long> ids, String password);

    CreateCountVo create(String prefix, Integer count, String password);

    int countByRole(Role role);

    List<UserVo> findAdmin();

    PageResult<UserVo> findUserPage(UserQuery query, User user);

    Long saveUser(UserEdit user);

}
