package cn.com.qmth.scancentral.service.impl;

import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.boot.core.exception.ParameterException;

import cn.com.qmth.scancentral.dao.FilePropertyDao;
import cn.com.qmth.scancentral.entity.FilePropertyEntity;
import cn.com.qmth.scancentral.service.FilePropertyService;

@Service
public class FilePropertyServiceImpl extends ServiceImpl<FilePropertyDao, FilePropertyEntity>
        implements FilePropertyService {

    @Transactional
    @Override
    public void save(Long examId, String path, String md5, Long fileSize) {
        if (examId == null) {
            throw new ParameterException("examId 不能为空");
        }
        if (StringUtils.isBlank(path)) {
            throw new ParameterException("path 不能为空");
        }
        if (StringUtils.isBlank(md5)) {
            throw new ParameterException("md5 不能为空");
        }
        FilePropertyEntity file = getById(path);
        if (file == null) {
            file = new FilePropertyEntity();
            file.setPath(path);
            file.setCreateTime(System.currentTimeMillis());
            file.setExamId(examId);
            file.setFileSize(fileSize);
        }
        file.setMd5(md5);
        this.saveOrUpdate(file);
    }

}
