package cn.com.qmth.scancentral.service.impl;

import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.boot.core.exception.ParameterException;

import cn.com.qmth.scancentral.dao.QuestionDao;
import cn.com.qmth.scancentral.entity.QuestionEntity;
import cn.com.qmth.scancentral.service.QuestionService;

@Service
public class QuestionServiceImpl extends ServiceImpl<QuestionDao, QuestionEntity> implements QuestionService {

    // @Autowired
    // private SubjectService subjectService;

    @Override
    public List<QuestionEntity> findBySubjectCode(String subjectCode) {
        QueryWrapper<QuestionEntity> wrapper = new QueryWrapper<>();
        LambdaQueryWrapper<QuestionEntity> lw = wrapper.lambda();
        lw.eq(QuestionEntity::getSubjectCode, subjectCode);
        return questionSort(baseMapper.selectList(lw));
    }

    private List<QuestionEntity> questionSort(List<QuestionEntity> list) {
        list.sort((o1, o2) -> {
            int i = o1.getMainNumber() - o2.getMainNumber();
            if (i == 0) {
                if (o1.getSubNumber().contains("-")) {
                    String[] o1s = o1.getSubNumber().split("-");
                    String[] o2s = o2.getSubNumber().split("-");
                    int j = Integer.parseUnsignedInt(o1s[0]) - Integer.parseUnsignedInt(o2s[0]);
                    if (j == 0) {
                        return Integer.parseUnsignedInt(o1s[1]) - Integer.parseUnsignedInt(o2s[1]);
                    } else {
                        return j;
                    }
                } else {
                    return Integer.parseUnsignedInt(o1.getSubNumber()) - Integer.parseUnsignedInt(o2.getSubNumber());
                }
            }
            return i;
        });
        return list;
    }

    @Transactional
    @Override
    public void deleteBySubjectCode(String subjectCode) {
        if (StringUtils.isBlank(subjectCode)) {
            throw new ParameterException("subjectCode不能为空");
        }
        QueryWrapper<QuestionEntity> wrapper = new QueryWrapper<>();
        LambdaQueryWrapper<QuestionEntity> lw = wrapper.lambda();
        lw.eq(QuestionEntity::getSubjectCode, subjectCode);
        this.baseMapper.delete(wrapper);

    }

    @Transactional
    @Override
    public int importQuestion(List<QuestionEntity> questionList) {
        // if (questionList.isEmpty()) {
        // throw new ParameterException("数据不能为空");
        // }
        // Long examId = questionList.get(0).getExamId();
        // this.deleteByExamId(examId);
        // Map<String, List<QuestionEntity>> map = new HashMap<String,
        // List<QuestionEntity>>();
        // for (QuestionEntity questionEntity : questionList) {
        // List<QuestionEntity> list = map.get(questionEntity.getSubjectCode());
        // if (list == null) {
        // list = new ArrayList<>();
        // }
        // list.add(questionEntity);
        // map.put(questionEntity.getSubjectCode(), list);
        // }
        // for (String subjectCode : map.keySet()) {
        // SubjectEntity subject = subjectService.findByExamIdAndCode(examId,
        // subjectCode);
        // if (subject == null) {
        // throw new ParameterException(subjectCode + "科目不存在");
        // }
        // }
        // this.saveOrUpdateBatch(questionList);
        // return questionList.size();
        return 0;
    }
}
