package cn.com.qmth.scancentral.service.impl;

import cn.com.qmth.scancentral.dao.SystemConfigDao;
import cn.com.qmth.scancentral.entity.SystemConfigEntity;
import cn.com.qmth.scancentral.service.SystemConfigService;
import cn.com.qmth.scancentral.vo.scannerinfo.Control;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.boot.core.exception.ParameterException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class SystemConfigServiceImpl extends ServiceImpl<SystemConfigDao, SystemConfigEntity>
        implements SystemConfigService {

    @Override
    public SystemConfigEntity find() {
        return getById(1L);
    }

    @Transactional
    @Override
    public Control control(Control control) {
        if (control.getEnableLogin() == null) {
            throw new ParameterException("EnableLogin不能为空");
        }
        if (control.getPassword() == null) {
            throw new ParameterException("Password不能为空");
        }
        SystemConfigEntity config = find();
        config.setScannerEnableLogin(control.getEnableLogin());
        config.setScannerPassword(control.getPassword());
        this.saveOrUpdate(config);
        return control;
    }

}
