package cn.com.qmth.scancentral.task;

import cn.com.qmth.scancentral.entity.ExamEntity;
import cn.com.qmth.scancentral.enums.ImageTransferMode;
import cn.com.qmth.scancentral.service.ExamService;
import cn.com.qmth.scancentral.service.ImageCheckService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ImageCheckJob {

    @Autowired
    private ExamService examService;

    @Autowired
    private ImageCheckService imageCheckService;

    @Scheduled(fixedDelay = 60000, initialDelay = 30000)
    public void process() {
        LambdaQueryWrapper<ExamEntity> wrapper = Wrappers.lambdaQuery();
        wrapper.select(ExamEntity::getId);
        wrapper.eq(ExamEntity::getEnable, true);
        List<ExamEntity> exams = examService.list(wrapper);

        for (ExamEntity exam : exams) {
            if (ImageTransferMode.CET.equals(exam.getImageTransferMode())) {
                imageCheckService.check(exam.getId());
            }
        }
    }

}
