package cn.com.qmth.scancentral.task.thread;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.qmth.boot.core.concurrent.service.ConcurrentService;
import com.qmth.boot.core.exception.StatusException;

import cn.com.qmth.scancentral.enums.LockType;
import cn.com.qmth.scancentral.service.StudentService;

public class CheckAssignedResetThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(CheckAssignedResetThread.class);

    private String subjectCode;

    private Long examId;

    private StudentService studentService;

    private ConcurrentService concurrentService;

    public CheckAssignedResetThread(Long examId, String subjectCode, StudentService studentService,
                                    ConcurrentService concurrentService) {
        this.examId = examId;
        this.subjectCode = subjectCode;
        this.studentService = studentService;
        this.concurrentService = concurrentService;
    }

    @Override
    public void run() {
        if (examId == null) {
            return;
        }
        if (subjectCode == null) {
            return;
        }
        try {
            if (concurrentService.getLock(LockType.CHECK_ASSIGNED_RESET + "-" + examId).tryLock()) {
                studentService.resetAssignedCheck(examId, subjectCode);
            }
        } catch (Exception e) {
            log.error("exam status reset error", e);
            throw new StatusException("缺考校验重新生成失败");
        } finally {
            concurrentService.getLock(LockType.CHECK_ASSIGNED_RESET + "-" + examId).unlock();
        }
    }

}
