package cn.com.qmth.scancentral.task.thread;

import cn.com.qmth.scancentral.enums.LockType;
import cn.com.qmth.scancentral.service.OmrGroupService;
import com.qmth.boot.core.concurrent.model.Semaphore;
import com.qmth.boot.core.concurrent.service.ConcurrentService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class OmrGroupDeleteThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(OmrGroupDeleteThread.class);

    private Long groupId;

    private OmrGroupService groupService;

    private ConcurrentService concurrentService;

    private Semaphore semaphore;

    public OmrGroupDeleteThread(Long groupId, OmrGroupService groupService, ConcurrentService concurrentService,
            Semaphore semaphore) {
        this.groupId = groupId;
        this.groupService = groupService;
        this.concurrentService = concurrentService;
        this.semaphore = semaphore;
    }

    @Override
    public void run() {
        try {
            log.info("OmrGroup[" + groupId + "] delete start");
            concurrentService.getLock(LockType.OMR_GROUP + "-" + groupId).lock();
            groupService.deleteById(groupId);
            log.info("OmrGroup[" + groupId + "] delete finish");
        } catch (

        Exception e) {
            log.error("OmrGroup[" + groupId + "] delete error", e);
            // throw new StatusException("删除识别对照分组失败");
        } finally {
            concurrentService.getLock(LockType.OMR_GROUP + "-" + groupId).unlock();
            semaphore.release();
        }
    }

}
