package cn.com.qmth.scancentral.task.thread;

import cn.com.qmth.scancentral.enums.LockType;
import cn.com.qmth.scancentral.service.OmrGroupService;
import com.qmth.boot.core.concurrent.model.Semaphore;
import com.qmth.boot.core.concurrent.service.ConcurrentService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class OmrGroupResetThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(OmrGroupResetThread.class);

    private Long groupId;

    private OmrGroupService groupService;

    private ConcurrentService concurrentService;

    private Semaphore semaphore;

    public OmrGroupResetThread(Long groupId, OmrGroupService groupService, ConcurrentService concurrentService,
            Semaphore semaphore) {
        this.groupId = groupId;
        this.groupService = groupService;
        this.concurrentService = concurrentService;
        this.semaphore = semaphore;
    }

    @Override
    public void run() {
        try {
            log.info("OmrGroup[" + groupId + "] reset start");
            concurrentService.getReadWriteLock(LockType.OMR_GROUP + "-" + groupId).readLock().lock();
            groupService.resetById(groupId);
            log.info("OmrGroup[" + groupId + "] reset finish");
        } catch (Exception e) {
            log.error("OmrGroup[" + groupId + "] reset error", e);
            // throw new StatusException("识别对照分组重置失败");
        } finally {
            concurrentService.getReadWriteLock(LockType.OMR_GROUP + "-" + groupId).readLock().unlock();
            semaphore.release();
        }
    }

}
