package cn.com.qmth.scancentral.vo;

import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import java.util.List;

public class ExamConfigVo {

    @ApiModelProperty(value = "考试ID")
    @NotNull(message = "考试ID不能为空")
    private Long examId;

    @ApiModelProperty(value = "卷型条码内容")
    @NotNull(message = "卷型条码内容不能为空")
    private List<String> paperTypeBarcodeContent;

    @ApiModelProperty(value = "图片抽查比例")
    @NotNull(message = "图片抽查比例不能为空")
    @Min(value = 0, message = "图片抽查比例不能小于0")
    @Max(value = 100, message = "图片抽查比例不能大于100")
    private Double imageCheckRatio;

    @ApiModelProperty(value = "图片抽查顺序", notes = "DESC-xxx、ASC-xxx")
    @NotNull(message = "图片抽查顺序不能为空")
    private String imageCheckOrder;

    @ApiModelProperty(value = "是否启用实时审核")
    @NotNull(message = "是否启用实时审核不能为空")
    private Boolean enableSyncVerify;

    @ApiModelProperty(value = "人工绑定锁屏数量")
    @NotNull(message = "人工绑定锁屏数量不能为空")
    @Min(value = 0, message = "人工绑定锁屏数量不能小于0")
    private Integer scannerAssignedMaxCount;

    @ApiModelProperty(value = "人工绑定解锁密码")
    @NotNull(message = "人工绑定解锁密码不能为空")
    private String scannerAssignedVerifyPassword;

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public List<String> getPaperTypeBarcodeContent() {
        return paperTypeBarcodeContent;
    }

    public void setPaperTypeBarcodeContent(List<String> paperTypeBarcodeContent) {
        this.paperTypeBarcodeContent = paperTypeBarcodeContent;
    }

    public Double getImageCheckRatio() {
        return imageCheckRatio;
    }

    public void setImageCheckRatio(Double imageCheckRatio) {
        this.imageCheckRatio = imageCheckRatio;
    }

    public String getImageCheckOrder() {
        return imageCheckOrder;
    }

    public void setImageCheckOrder(String imageCheckOrder) {
        this.imageCheckOrder = imageCheckOrder;
    }

    public Boolean getEnableSyncVerify() {
        return enableSyncVerify;
    }

    public void setEnableSyncVerify(Boolean enableSyncVerify) {
        this.enableSyncVerify = enableSyncVerify;
    }

    public Integer getScannerAssignedMaxCount() {
        return scannerAssignedMaxCount;
    }

    public void setScannerAssignedMaxCount(Integer scannerAssignedMaxCount) {
        this.scannerAssignedMaxCount = scannerAssignedMaxCount;
    }

    public String getScannerAssignedVerifyPassword() {
        return scannerAssignedVerifyPassword;
    }

    public void setScannerAssignedVerifyPassword(String scannerAssignedVerifyPassword) {
        this.scannerAssignedVerifyPassword = scannerAssignedVerifyPassword;
    }

}
