package cn.com.qmth.scancentral.vo;

import cn.com.qmth.scancentral.enums.ConditionType;
import cn.com.qmth.scancentral.model.OmrCondition;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;

public class OmrGroupUpdateVo {

    private Long id;

    private Long examId;

    private String subjectCode;

    private List<OmrConditionUpdateVo> conditions;

    @ApiModelProperty(hidden = true)
    private Long userId;

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public List<OmrConditionUpdateVo> getConditions() {
        return conditions;
    }

    public void setConditions(List<OmrConditionUpdateVo> conditions) {
        this.conditions = conditions;
    }

    public List<OmrCondition> getConditionList() {
        List<OmrCondition> list = new ArrayList<>();
        if (conditions != null) {
            for (OmrConditionUpdateVo vo : conditions) {
                ConditionType type = ConditionType.findByCode(vo.getCode());
                if (type != null) {
                    OmrCondition condition = new OmrCondition();
                    condition.setCode(type);
                    condition.setValue(vo.getValue());
                    list.add(condition);
                }
            }
        }
        return list;
    }

}
