package cn.com.qmth.scancentral.vo.answerquery;

import cn.com.qmth.scancentral.enums.ExamStatus;
import cn.com.qmth.scancentral.enums.PaperTypeStatus;
import cn.com.qmth.scancentral.enums.ScanStatus;
import cn.com.qmth.scancentral.util.PagerQuery;

import javax.validation.constraints.NotNull;
import java.util.List;

public class AnswerQueryParam extends PagerQuery {

    @NotNull(message = "考试ID不能为空")
    private Long examId;

    private List<ScanStatus> status;

    private List<ExamStatus> examStatus;

    private String examNumber;

    private String name;

    private String packageCode;

    private String campusCode;

    private String campusName;

    private String subjectCode;

    private String examSite;

    private String examRoom;

    private String province;

    private PaperTypeStatus paperTypeStatus;

    private String device;

    private Boolean absentSuspect;

    private Boolean omrAbsent;

    private Boolean assigned;

    private Boolean incomplete;

    private Boolean questionFilled;

    private Boolean withOmrDetail;

    private Boolean subjectiveFilled;

    private Boolean hasFilled;

    private Boolean assignedSuspect;

    private Integer assignedCheckCount;

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public List<ScanStatus> getStatus() {
        return status;
    }

    public void setStatus(List<ScanStatus> status) {
        this.status = status;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPackageCode() {
        return packageCode;
    }

    public void setPackageCode(String packageCode) {
        this.packageCode = packageCode;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getExamSite() {
        return examSite;
    }

    public void setExamSite(String examSite) {
        this.examSite = examSite;
    }

    public String getExamRoom() {
        return examRoom;
    }

    public void setExamRoom(String examRoom) {
        this.examRoom = examRoom;
    }

    public Boolean getAbsentSuspect() {
        return absentSuspect;
    }

    public void setAbsentSuspect(Boolean absentSuspect) {
        this.absentSuspect = absentSuspect;
    }

    public Boolean getOmrAbsent() {
        return omrAbsent;
    }

    public void setOmrAbsent(Boolean omrAbsent) {
        this.omrAbsent = omrAbsent;
    }

    public Boolean getAssigned() {
        return assigned;
    }

    public void setAssigned(Boolean assigned) {
        this.assigned = assigned;
    }

    public Boolean getIncomplete() {
        return incomplete;
    }

    public void setIncomplete(Boolean incomplete) {
        this.incomplete = incomplete;
    }

    public Boolean getQuestionFilled() {
        return questionFilled;
    }

    public void setQuestionFilled(Boolean questionFilled) {
        this.questionFilled = questionFilled;
    }

    public Boolean getWithOmrDetail() {
        return withOmrDetail;
    }

    public void setWithOmrDetail(Boolean withOmrDetail) {
        this.withOmrDetail = withOmrDetail;
    }

    public List<ExamStatus> getExamStatus() {
        return examStatus;
    }

    public void setExamStatus(List<ExamStatus> examStatus) {
        this.examStatus = examStatus;
    }

    public String getCampusCode() {
        return campusCode;
    }

    public void setCampusCode(String campusCode) {
        this.campusCode = campusCode;
    }

    public PaperTypeStatus getPaperTypeStatus() {
        return paperTypeStatus;
    }

    public void setPaperTypeStatus(PaperTypeStatus paperTypeStatus) {
        this.paperTypeStatus = paperTypeStatus;
    }

    public String getDevice() {
        return device;
    }

    public void setDevice(String device) {
        this.device = device;
    }

    public String getCampusName() {
        return campusName;
    }

    public void setCampusName(String campusName) {
        this.campusName = campusName;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public Boolean getSubjectiveFilled() {
        return subjectiveFilled;
    }

    public void setSubjectiveFilled(Boolean subjectiveFilled) {
        this.subjectiveFilled = subjectiveFilled;
    }

    public Boolean getAssignedSuspect() {
        return assignedSuspect;
    }

    public void setAssignedSuspect(Boolean assignedSuspect) {
        this.assignedSuspect = assignedSuspect;
    }

    public Integer getAssignedCheckCount() {
        return assignedCheckCount;
    }

    public void setAssignedCheckCount(Integer assignedCheckCount) {
        this.assignedCheckCount = assignedCheckCount;
    }

    public Boolean getHasFilled() {
        return hasFilled;
    }

    public void setHasFilled(Boolean hasFilled) {
        this.hasFilled = hasFilled;
    }

}
