package cn.com.qmth.scancentral.vo.batchdetail;

import java.util.ArrayList;
import java.util.List;

public class BatchStudentVo {

    private Long id;

    private String examNumber;

    private String name;

    private String subjectCode;

    private String subjectName;

    private Boolean omrAbsent;

    private Boolean assigned;

    private List<BatchPaperVo> papers;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public Boolean getOmrAbsent() {
        return omrAbsent;
    }

    public void setOmrAbsent(Boolean omrAbsent) {
        this.omrAbsent = omrAbsent;
    }

    public Boolean getAssigned() {
        return assigned;
    }

    public void setAssigned(Boolean assigned) {
        this.assigned = assigned;
    }

    public List<BatchPaperVo> getPapers() {
        return papers;
    }

    public void setPapers(List<BatchPaperVo> papers) {
        this.papers = papers;
    }

    public static BatchStudentVo build(BatchDetailDO item) {
        BatchStudentVo detail = new BatchStudentVo();
        detail.setId(item.getId());
        detail.setExamNumber(item.getExamNumber());
        detail.setName(item.getName());
        detail.setSubjectCode(item.getSubjectCode());
        detail.setSubjectName(item.getSubjectName());
        detail.setOmrAbsent(false);
        detail.setAssigned(false);
        detail.setPapers(new ArrayList<>());
        return detail;
    }

    public BatchPaperVo findOrCreatePaper(BatchDetailDO item) {
        BatchPaperVo paper = null;
        for (BatchPaperVo paperVo : papers) {
            if (paperVo.getNumber().equals(item.getPaperNumber())) {
                paper = paperVo;
                break;
            }
        }
        if (paper == null) {
            paper = new BatchPaperVo();
            paper.setNumber(item.getPaperNumber());
            paper.setAssigned(item.getAssigned());
            paper.setPages(new ArrayList<>());
            papers.add(paper);
        }
        return paper;
    }
}
