package cn.com.qmth.scancentral.vo.task;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

public class TaskResultVo {

    @NotNull(message = "任务ID不能为空")
    private Long id;

    @Valid
    @NotNull(message = "任务pages不能为空")
    @Size(min = 1, message = "任务pages不能为空")
    private List<TaskResultPageVo> pages;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public List<TaskResultPageVo> getPages() {
        return pages;
    }

    public TaskResultPageVo findPage(Integer index) {
        if (pages != null) {
            for (TaskResultPageVo vo : pages) {
                if (vo.getIndex().equals(index)) {
                    return vo;
                }
            }
        }
        return null;
    }

    public void setPages(List<TaskResultPageVo> pages) {
        this.pages = pages;
    }

}
