package cn.com.qmth.scancentral.vo.verify;

import cn.com.qmth.scancentral.vo.batchdetail.BatchDetailDO;

import java.util.ArrayList;
import java.util.List;

public class VerifyStudentVo {

    private String examNumber;

    private String name;

    private String subjectCode;

    private String subjectName;

    private String seatNumber;

    private List<VerifyPaperVo> papers;

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public List<VerifyPaperVo> getPapers() {
        return papers;
    }

    public void setPapers(List<VerifyPaperVo> papers) {
        this.papers = papers;
    }

    public static VerifyStudentVo build(BatchDetailDO item) {
        VerifyStudentVo student = new VerifyStudentVo();
        student.setExamNumber(item.getExamNumber());
        student.setName(item.getName());
        student.setSubjectCode(item.getSubjectCode());
        student.setSubjectName(item.getSubjectName());
        student.setSeatNumber(item.getSeatNumber());
        student.setPapers(new ArrayList<>());
        return student;
    }

    public VerifyPaperVo findOrCreatePaper(BatchDetailDO item) {
        VerifyPaperVo paper = null;
        for (VerifyPaperVo paperVo : papers) {
            if (paperVo.getNumber().equals(item.getPaperNumber())) {
                paper = paperVo;
                break;
            }
        }
        if (paper == null) {
            paper = new VerifyPaperVo();
            paper.setNumber(item.getPaperNumber());
            paper.setAssgined(item.getAssigned());
            paper.setPages(new ArrayList<String>());
            papers.add(paper);
        }
        return paper;
    }

    public String getSeatNumber() {
        return seatNumber;
    }

    public void setSeatNumber(String seatNumber) {
        this.seatNumber = seatNumber;
    }

}
